## libpodofo 0.9.3

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

#*****************  IMPORTANT  ************* IMPORTANT **********************
# Look at http://www.vtk.org/Wiki/CMake_HowToDoPlatformChecks
# and the other wiki entries before you add anything. You might not need to.
#****************************************************************************

#
# Project name and version
#
PROJECT(PoDoFo)

SET(PODOFO_VERSION_MAJOR "0" CACHE STRING "Major part of PoDoFo version number")
SET(PODOFO_VERSION_MINOR "9" CACHE STRING "Minor part of PoDoFo version number")
SET(PODOFO_VERSION_PATCH "3" CACHE STRING "Patchlevel part of PoDoFo version number")
SET(PODOFO_SOVERSION "${PODOFO_VERSION_MAJOR}.${PODOFO_VERSION_MINOR}.${PODOFO_VERSION_PATCH}")
SET(PODOFO_LIBVERSION "${PODOFO_SOVERSION}")


#
# Main includes
#
INCLUDE(CheckIncludeFile)
INCLUDE(CheckLibraryExists)
INCLUDE(UsePkgConfig)
INCLUDE(TestBigEndian)
INCLUDE(CheckTypeSize)

# Load modules from our source tree too
SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")


# Builds must use this CMakeLists.txt, not the one in src/ or somewhere else.
# If users try to use something else the results can be confusing. We set a
# variable here that we require to be set elsewhere, otherwise we'll complain.
SET(PODOFO_MAIN_CMAKELISTS_READ TRUE)


# If the user hasn't told use specifically what they want, build only
# a static library.
IF(NOT DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
    SET(PODOFO_BUILD_STATIC TRUE)
    SET(PODOFO_BUILD_SHARED FALSE)
ENDIF(NOT DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
IF(DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
    SET(PODOFO_BUILD_SHARED NOT ${PODOFO_BUILD_SHARED})
ENDIF(DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
IF(NOT DEFINED PODOFO_BUILD_SHARED AND DEFINED PODOFO_BUILD_STATIC)
    SET(PODOFO_BUILD_SHARED NOT ${PODOFO_BUILD_STATIC})
ENDIF(NOT DEFINED PODOFO_BUILD_SHARED AND DEFINED PODOFO_BUILD_STATIC)

# Some 64 bit linux distros use /usr/lib64 for 64 bit libraries.
# on these platforms we must
IF(NOT DEFINED WANT_LIB64)
	# TODO: detect 64-bit build and existance of /usr/lib64 and set to TRUE.
	MESSAGE("WANT_LIB64 unset; assuming normal library directory names")
	SET(WANT_LIB64 FALSE)
ENDIF(NOT DEFINED WANT_LIB64)

IF(WANT_LIB64)
	SET(LIBDIRNAME "lib64")
ELSE(WANT_LIB64)
	SET(LIBDIRNAME "lib")
ENDIF(WANT_LIB64)
MESSAGE("Will install libraries to ${CMAKE_INSTALL_PREFIX}/${LIBDIRNAME}")

# Some headers that tend to vary a bit
CHECK_INCLUDE_FILE("strings.h" PODOFO_HAVE_STRINGS_H) 
CHECK_INCLUDE_FILE("arpa/inet.h" PODOFO_HAVE_ARPA_INET_H) 
CHECK_INCLUDE_FILE("winsock2.h" PODOFO_HAVE_WINSOCK2_H) 
CHECK_INCLUDE_FILE("mem.h" PODOFO_HAVE_MEM_H) 
CHECK_INCLUDE_FILE("ctype.h" PODOFO_HAVE_CTYPE_H) 

# Do some type size detection and provide yet another set of typedefs for fixed
# font sizes. We can't use the c99 / c++0x uint32_t etc, because people use
# ancient compilers that don't and will never support the standard.

CHECK_INCLUDE_FILE("sys/types.h" PODOFO_HAVE_SYS_TYPES_H) 
CHECK_INCLUDE_FILE("stdint.h" PODOFO_HAVE_STDINT_H) 
# See: http://msdn.microsoft.com/en-us/library/aa384264(VS.85).aspx
CHECK_INCLUDE_FILE("BaseTsd.h" PODOFO_HAVE_BASETSD_H) 

CHECK_TYPE_SIZE("long int" SZ_LONG)

# We cache integer type detection results, and don't repeat them
# (and overwrite the user's manual changes) if they've been done already.
IF(NOT PDF_INT64_TYPENAME)
  # I hate old compilers.
  IF(PODOFO_HAVE_STDINT_H)
    SET(pdfint8 "int8_t")
    SET(pdfint16 "int16_t")
    SET(pdfint32 "int32_t")
    SET(pdfint64 "int64_t")
    SET(pdfuint8 "uint8_t")
    SET(pdfuint16 "uint16_t")
    SET(pdfuint32 "uint32_t")
    SET(pdfuint64 "uint64_t")
    CHECK_TYPE_SIZE("int64_t" SZ_INT64)
  ELSE(PODOFO_HAVE_STDINT_H)
    # No stdint.h . Try BaseTsd.h windows types.
    IF(PODOFO_HAVE_BASETSD_H)
       # We have BaseTsd.h, so use those types.
       SET(pdfint8  "signed char")
       SET(pdfint16 "short")
       SET(pdfint32 "INT32")
       SET(pdfint64 "INT64")
       SET(pdfuint8 "unsigned char")
       SET(pdfuint16 "unsigned short")
       SET(pdfuint32 "UINT32")
       SET(pdfuint64 "UINT64")
       CHECK_TYPE_SIZE("INT64" SZ_INT64)
    ELSE(PODOFO_HAVE_BASETSD_H)
       # No BaseTsd.h either. Assume the standard types, and go poking
       # for a sane 64-bit integer.
       #
       # First, though, make sure sizeof(int) = 4 and if not, scream, because
       # hopefully this case will never be hit and we'll never have to write
       # the horrible code check for
       CHECK_TYPE_SIZE("signed char"        SZ_TINY_INT)
       CHECK_TYPE_SIZE("unsigned char"      SZ_TINY_UINT)
       CHECK_TYPE_SIZE("short int"          SZ_SHORT_INT)
       CHECK_TYPE_SIZE("int"                SZ_INT)
       CHECK_TYPE_SIZE("unsigned short int" SZ_UINT)
       CHECK_TYPE_SIZE("unsigned int"       SZ_SHORT_UINT)
       SET(smallintsok SZ_INT == 4 AND SZ_UINT == 4 AND SZ_SHORT_INT == 2 AND SZ_SHORT_UINT == 2 AND SZ_TINY_INT == 1 AND SZ_TINY_UINT == 1)
       IF(NOT smallintsok)
         MESSAGE(FATAL "sizeof(int) != 4 and/or sizeof(short) != 2 and no stdint.h or BaseTsd.h found. We don't know how to cope with this.")
       ENDIF(NOT smallintsok)
       SET(pdfint8 "signed char")
       SET(pdfint16 "short")
       SET(pdfint32 "int")
       SET(pdfuint8 "unsigned char")
       SET(pdfuint16 "unsigned short")
       SET(pdfuint32 "unsigned int")
       # Now we just have to figure out what 64-bit integer type we can use.
       #
       # Do we have VC >= 6's __uint64 and __int64?
       # See: http://icfun.blogspot.com/2008/04/use-of-int64-variable-in-c.html
       CHECK_TYPE_SIZE("__int64" SZ___INT64)
       CHECK_TYPE_SIZE("__uint64"  SZ___UINT64)
       IF(SZ___INT64 == 8 AND SZ___UINT64 == 8)
         # MS compiler, VC6 or newer without BaseTsd.h in SDK
         SET(pdfint64 "__int64")
         SET(pdfuint64 "__uint64")
	 CHECK_TYPE_SIZE("__int64" SZ_INT64)
       ELSE(SZ___INT64 AND SZ___UINT64)
         # Still no luck. Old unix compiler, Borland, or some other monster?
         # Are we lucky and sizeof(long) == 8?
         CHECK_TYPE_SIZE("unsigned long int" SZ_ULONG)
         IF(SZ_LONG == 8 AND SZ_ULONG == 8)
           # Must be on a LP64 platform, sizeof(long) = 8
           SET(pdfint64 "long int")
           SET(pdfuint64 "unsigned long int")
	   CHECK_TYPE_SIZE("long int" SZ_INT64)
         ELSE(SZ_LONG == 8 AND SZ_ULONG == 8)
           # See if the compiler implements "long long int", _int64, int64, __int64 or int64_t
           IF(PODOFO_HAVE_SYS_TYPES_H)
             SET(CMAKE_EXTRA_INCLUDE_FILES "sys/types.h")
           ENDIF(PODOFO_HAVE_SYS_TYPES_H)
           CHECK_TYPE_SIZE("long long int"          SZ_LONG_LONG)
           CHECK_TYPE_SIZE("unsigned long long int" SZ_UNSIGNED_LONG_LONG)
           IF(SZ_LONG_LONG == 8 AND SZ_UNSIGNED_LONG_LONG == 8)
             SET(pdfint64 "long int")
             SET(pdfuint64 "unsigned long int")
	     CHECK_TYPE_SIZE("long int" SZ_INT64)
           ELSE(SZ_LONG_LONG == 8 AND SZ_UNSIGNED_LONG_LONG == 8)
             CHECK_TYPE_SIZE("int64_t"                SZ_INT64_T)
             CHECK_TYPE_SIZE("uint64_t"               SZ_UINT64_T)
             IF(SZ_INT64_T AND SZ_UINT64_T)
               SET(pdfint64 "int64_t")
               SET(pdfuint64 "uint64_t")
	       CHECK_TYPE_SIZE("int64_t" SZ_INT64)
             ELSE(SZ_INT64_T AND SZ_UINT64_T)
               CHECK_TYPE_SIZE("int64"                SZ_INT64)
               CHECK_TYPE_SIZE("uint64"               SZ_UINT64)
               IF(SZ_INT64 AND SZ_UINT64)
                 SET(pdfint64 "int64")
                 SET(pdfuint64 "uint64")
		 CHECK_TYPE_SIZE("int64" SZ_INT64)
               ELSE(SZ_INT64 AND SZ_UINT64)
                 CHECK_TYPE_SIZE("_int64"                SZ__INT64)
                 CHECK_TYPE_SIZE("_uint64"               SZ__UINT64)
                 IF(SZ__INT64 AND SZ__UINT64)
                   SET(pdfint64 "_int64")
                   SET(pdfuint64 "_uint64")
		   CHECK_TYPE_SIZE("_int64" SZ_INT64)
                 ELSE(SZ__INT64 AND SZ__UINT64)
                   MESSAGE("Oh my lord, your compiler doesn't seem to support any of the int64 type flavours we tried.")
                   MESSAGE(WARNING "You must set the PDF_INTxx_TYPENAME and PDF_UINTxx_TYPENAME variables manually")
                 ENDIF(SZ__INT64 AND SZ__UINT64)
               ENDIF(SZ_INT64 AND SZ_UINT64)
             ENDIF(SZ_INT64_T AND SZ_UINT64_T)
           ENDIF(SZ_LONG_LONG == 8 AND SZ_UNSIGNED_LONG_LONG == 8)
         ENDIF(SZ_LONG == 8 AND SZ_ULONG == 8)
       ENDIF(SZ___INT64 AND SZ___UINT64)
    ENDIF(PODOFO_HAVE_BASETSD_H)
  ENDIF(PODOFO_HAVE_STDINT_H)
  SET(CMAKE_EXTRA_INCLUDE_FILES)
ENDIF(NOT PDF_INT64_TYPENAME)

IF(NOT PDF_INT64_TYPENAME AND pdfint64)
  SET(PDF_INT64_TYPENAME  "${pdfint64}" CACHE STRING "Name of detected 64-bit signed integer type to use")
  SET(PDF_INT32_TYPENAME  "${pdfint32}" CACHE STRING "Name of detected 32-bit signed integer type to use")
  SET(PDF_INT16_TYPENAME  "${pdfint16}" CACHE STRING "Name of detected 16-bit signed integer type to use")
  SET(PDF_INT8_TYPENAME   "${pdfint8}" CACHE STRING "Name of detected 8-bit signed integer type to use")
  SET(PDF_UINT64_TYPENAME "${pdfuint64}" CACHE STRING "Name of detected 64-bit unsigned integer type to use")
  SET(PDF_UINT32_TYPENAME "${pdfuint32}" CACHE STRING "Name of detected 32-bit unsigned integer type to use")
  SET(PDF_UINT16_TYPENAME "${pdfuint16}" CACHE STRING "Name of detected 16-bit unsigned integer type to use")
  SET(PDF_UINT8_TYPENAME  "${pdfuint8}" CACHE STRING "Name of detected 8-bit unsigned integer type to use")
ENDIF(NOT PDF_INT64_TYPENAME AND pdfint64)

# Linux packagers want an uninstall target.
CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall "${CMAKE_COMMAND}"
    -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# Check if we are big endian
TEST_BIG_ENDIAN(TEST_BIG)

IF(WIN32)
    # On win32 we support EITHER shared OR static builds.
    # If both are enabled (default), turn off generation of the
    # static library.
    IF(PODOFO_BUILD_SHARED AND PODOFO_BUILD_STATIC)
         MESSAGE("Both PODOFO_BUILD_SHARED and PODOFO_BUILD_STATIC set")
         MESSAGE("  so disabling shared library generation (win32)")
         SET(PODOFO_BUILD_SHARED FALSE)
         SET(PODOFO_BUILD_STATIC TRUE)
    ENDIF(PODOFO_BUILD_SHARED AND PODOFO_BUILD_STATIC)
    # We must explicitly link to the core win32 libraries, and we need winsock2
    # to get some byte-order conversion routines too.
    SET(PLATFORM_SYSTEM_LIBRARIES kernel32 user32 gdi32 winspool comdlg32 advapi32 shell32 ole32 oleaut32 uuid WS2_32)
    # Microsoft deprecate certain POSIX functions that we use.
    # for now, turn off these warnings.
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
    # We need a fake unistd.h for some libraries to build. They try to include <unistd.h>
    # which is not available under win32 with MSVC++, but everything in unistd.h is defined,
    # so an empty file solves the issue.
    SET(EXTRA_INCLUDES ${PoDoFo_SOURCE_DIR}/vcincludes)
ELSE(WIN32)
    SET(PLATFORM_SYSTEM_LIBRARIES)
    SET(EXTRA_INCLUDES)
ENDIF(WIN32)

IF(UNIX AND NOT PODOFO_NO_FONTMANAGER)
    SET(WANT_FONTCONFIG TRUE CACHE INTERNAL
        "True if PoDoFo should be built with fontconfig support")
ELSE(UNIX AND NOT PODOFO_NO_FONTMANAGER)
    SET(WANT_FONTCONFIG FALSE CACHE INTERNAL
        "True if PoDoFo should be built with fontconfig support")
ENDIF(UNIX AND NOT PODOFO_NO_FONTMANAGER)


IF(CMAKE_COMPILER_IS_GNUCXX)
    MESSAGE("Using gcc specific compiler options")
    # We can be more specific about what we want out of g++
    # than with most other compilers.

    # Attempt to detect the gcc version. You must not rely on

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
IF(NOT PODOFO_MAIN_CMAKELISTS_READ)
  MESSAGE(FATAL_ERROR "Run cmake on the CMakeLists.txt in the project root, not the one in the 'src' directory. You will need to delete CMakeCache.txt from the current directory.")
ENDIF(NOT PODOFO_MAIN_CMAKELISTS_READ)

SET(PODOFO_BASE_DEPEND_TARGET CACHE INTERNAL
    "Which PoDoFo library target to depend on when building tools and tests")
SET(PODOFO_DEPEND_TARGET CACHE INTERNAL
    "Which PoDoFo library target to depend on when building tools and tests")

SET(PODOFO_BASE_SOURCES
  base/PdfArray.cpp
  base/PdfCanvas.cpp
  base/PdfColor.cpp
  base/PdfContentsTokenizer.cpp
  base/PdfData.cpp
  base/PdfDataType.cpp
  base/PdfDate.cpp
  base/PdfDictionary.cpp
  base/PdfEncoding.cpp
  base/PdfEncodingFactory.cpp
  base/PdfEncrypt.cpp
  base/PdfError.cpp
  base/PdfFileStream.cpp
  base/PdfFilter.cpp
  base/PdfFiltersPrivate.cpp
  base/PdfImmediateWriter.cpp
  base/PdfInputDevice.cpp
  base/PdfInputStream.cpp
  base/PdfLocale.cpp
  base/PdfMemStream.cpp
  base/PdfMemoryManagement.cpp
  base/PdfName.cpp
  base/PdfObject.cpp
  base/PdfObjectStreamParserObject.cpp
  base/PdfOutputDevice.cpp
  base/PdfOutputStream.cpp
  base/PdfParser.cpp
  base/PdfParserObject.cpp
  base/PdfRect.cpp
  base/PdfRefCountedBuffer.cpp
  base/PdfRefCountedInputDevice.cpp
  base/PdfReference.cpp
  base/PdfSigIncWriter.cpp
  base/PdfStream.cpp
  base/PdfString.cpp
  base/PdfTokenizer.cpp
  base/PdfVariant.cpp
  base/PdfVecObjects.cpp
  base/PdfWriter.cpp
  base/PdfXRef.cpp
  base/PdfXRefStream.cpp
  base/PdfXRefStreamParserObject.cpp
  )

SET(PODOFO_DOC_SOURCES
  doc/PdfAcroForm.cpp
  doc/PdfAction.cpp
  doc/PdfAnnotation.cpp
  doc/PdfCMapEncoding.cpp
  doc/PdfContents.cpp
  doc/PdfDestination.cpp
  doc/PdfDifferenceEncoding.cpp
  doc/PdfDocument.cpp
  doc/PdfElement.cpp
  doc/PdfEncodingObjectFactory.cpp
  doc/PdfExtGState.cpp
  doc/PdfField.cpp
  doc/PdfFileSpec.cpp
  doc/PdfFont.cpp
  doc/PdfFontCID.cpp
  doc/PdfFontCache.cpp
  doc/PdfFontConfigWrapper.cpp
  doc/PdfFontFactory.cpp
  doc/PdfFontMetrics.cpp
  doc/PdfFontMetricsBase14.cpp
  doc/PdfFontMetricsFreetype.cpp
  doc/PdfFontMetricsObject.cpp
  doc/PdfFontSimple.cpp
  doc/PdfFontTTFSubset.cpp
  doc/PdfFontTrueType.cpp
  doc/PdfFontType1.cpp
  doc/PdfFontType3.cpp
  doc/PdfFontType1Base14.cpp
  doc/PdfFunction.cpp
  doc/PdfHintStream.cpp
  doc/PdfIdentityEncoding.cpp
  doc/PdfImage.cpp
  doc/PdfInfo.cpp
  doc/PdfMemDocument.cpp
  doc/PdfNamesTree.cpp
  doc/PdfOutlines.cpp
  doc/PdfPage.cpp
  doc/PdfPagesTree.cpp
  doc/PdfPagesTreeCache.cpp
  doc/PdfPainter.cpp
  doc/PdfPainterMM.cpp
  doc/PdfShadingPattern.cpp
  doc/PdfSigIncMemDocument.cpp
  doc/PdfSigIncPainter.cpp
  doc/PdfSigIncSignatureField.cpp
  doc/PdfSignOutputDevice.cpp
  doc/PdfSignatureField.cpp
  doc/PdfStreamedDocument.cpp
  doc/PdfTable.cpp
  doc/PdfTilingPattern.cpp
  doc/PdfXObject.cpp
  )

IF(WIN32)
    # If we build for windows systems, we also include the resource file
    SET(PODOFO_DOC_SOURCES ${PODOFO_DOC_SOURCES} doc/podofo-doc.rc)
ENDIF(WIN32)

SET(PODOFO_HEADERS
  podofo-base.h
  podofo.h)

SET(PODOFO_BASE_HEADERS
   ${PoDoFo_BINARY_DIR}/podofo_config.h
   base/Pdf3rdPtyForwardDecl.h
   base/PdfArray.h
   base/PdfCanvas.h
   base/PdfColor.h
   base/PdfCompilerCompat.h
   base/PdfCompilerCompatPrivate.h
   base/PdfContentsTokenizer.h
   base/PdfData.h
   base/PdfDataType.h
   base/PdfDate.h
   base/PdfDefines.h
   base/PdfDefinesPrivate.h
   base/PdfDictionary.h
   base/PdfEncoding.h
   base/PdfEncodingFactory.h
   base/PdfEncrypt.h
   base/PdfExtension.h
   base/PdfError.h
   base/PdfFileStream.h
   base/PdfFilter.h
   base/PdfFiltersPrivate.h
   base/PdfImmediateWriter.h
   base/PdfInputDevice.h
   base/PdfInputStream.h
   base/PdfLocale.h
   base/PdfMemStream.h
   base/PdfMemoryManagement.h
   base/PdfName.h
   base/PdfObject.h
   base/PdfObjectStreamParserObject.h
   base/PdfOutputDevice.h
   base/PdfOutputStream.h
   base/PdfParser.h
   base/PdfParserObject.h
   base/PdfRect.h
   base/PdfRefCountedBuffer.h
   base/PdfRefCountedInputDevice.h
   base/PdfReference.h
   base/PdfSigIncWriter.h
   base/PdfStream.h
   base/PdfString.h
   base/PdfTokenizer.h
   base/PdfVariant.h
   base/PdfVecObjects.h
   base/PdfVersion.h
   base/PdfWriter.h
   base/PdfXRef.h
   base/PdfXRefStream.h
   base/PdfXRefStreamParserObject.h
   base/podofoapi.h
   )

SET(PODOFO_BASE_HEADERS2 
    base/util/PdfMutex.h
    base/util/PdfMutexImpl_noop.h
    base/util/PdfMutexImpl_win32.h
    base/util/PdfMutexImpl_pthread.h
    base/util/PdfMutexWrapper.h
    )

SET(PODOFO_DOC_HEADERS
  doc/PdfAcroForm.h
  doc/PdfAction.h
  doc/PdfAnnotation.h
  doc/PdfCMapEncoding.h
  doc/PdfContents.h
  doc/PdfDestination.h
  doc/PdfDifferenceEncoding.h
  doc/PdfDocument.h
  doc/PdfElement.h
  doc/PdfEncodingObjectFactory.h
  doc/PdfExtGState.h
  doc/PdfField.h
  doc/PdfFileSpec.h
  doc/PdfFont.h
  doc/PdfFontCID.h
  doc/PdfFontCache.h
  doc/PdfFontConfigWrapper.h
  doc/PdfFontFactory.h
  doc/PdfFontFactoryBase14Data.h
  doc/PdfFontMetrics.h
  doc/PdfFontMetricsBase14.h
  doc/PdfFontMetricsFreetype.h
  doc/PdfFontMetricsObject.h
  doc/PdfFontSimple.h
  doc/PdfFontTTFSubset.h
  doc/PdfFontTrueType.h
  doc/PdfFontType1.h
  doc/PdfFontType3.h
  doc/PdfFontType1Base14.h
  doc/PdfFunction.h
  doc/PdfHintStream.h
  doc/PdfIdentityEncoding.h
  doc/PdfImage.h
  doc/PdfInfo.h
  doc/PdfMemDocument.h
  doc/PdfNamesTree.h
  doc/PdfOutlines.h
  doc/PdfPage.h
  doc/PdfPagesTree.h
  doc/PdfPagesTreeCache.h
  doc/PdfPainter.h
  doc/PdfPainterMM.h
  doc/PdfShadingPattern.h
  doc/PdfSigIncMemDocument.h
  doc/PdfSigIncPainter.h
  doc/PdfSigIncSignatureField.h
  doc/PdfSignOutputDevice.h
  doc/PdfSignatureField.h
  doc/PdfStreamedDocument.h
  doc/PdfTable.h
  doc/PdfTilingPattern.h
  doc/PdfXObject.h
  )

# Create a Source Group for Visual Studio
# so that headers are listed in the folder view
# and are easier accessible
SOURCE_GROUP(Headers FILES 
  ${PODOFO_HEADERS} 
  ${PODOFO_BASE_HEADERS} 
  ${PODOFO_BASE_HEADERS2} 
  ${PODOFO_DOC_HEADERS})

INSTALL(FILES ${PODOFO_HEADERS}
  DESTINATION "include/podofo"
  )

INSTALL(FILES ${PODOFO_BASE_HEADERS}
    DESTINATION "include/podofo/base"
    )

INSTALL(FILES ${PODOFO_BASE_HEADERS2}
    DESTINATION "include/podofo/base/util"
    )

INSTALL(FILES ${PODOFO_DOC_HEADERS}
    DESTINATION "include/podofo/doc"
    )

IF(NOT PODOFO_BUILD_SHARED AND NOT PODOFO_BUILD_STATIC)
    MESSAGE(FATAL_ERROR "At least one of PODOFO_BUILD_SHARED and PODOF_BUILD_STATIC must be set")
ENDIF(NOT PODOFO_BUILD_SHARED AND NOT PODOFO_BUILD_STATIC)

IF(PODOFO_BUILD_STATIC)
    MESSAGE("Building static PoDoFo library")
    ADD_LIBRARY(podofo_static STATIC ${PODOFO_BASE_SOURCES} ${PODOFO_DOC_SOURCES})
    TARGET_LINK_LIBRARIES(podofo_static ${PODOFO_LIB_DEPENDS})
    SET_TARGET_PROPERTIES(podofo_static PROPERTIES
        VERSION "${PODOFO_LIBVERSION}"
        SOVERSION "${PODOFO_SOVERSION}"
        CLEAN_DIRECT_OUTPUT 1
        OUTPUT_NAME "podofo"
        COMPILE_FLAGS "-DBUILDING_PODOFO"
        )
    SET(PODOFO_DEPEND_TARGET podofo_static
        CACHE INTERNAL "Which PoDoFo library variant to depend on")
    SET(USING_SHARED_PODOFO FALSE)
    INSTALL(TARGETS podofo_static
        RUNTIME DESTINATION "bin"
        LIBRARY DESTINATION "${LIBDIRNAME}"
        ARCHIVE DESTINATION "${LIBDIRNAME}"
        )
ENDIF(PODOFO_BUILD_STATIC)

IF(PODOFO_BUILD_SHARED)
    MESSAGE("Building shared PoDoFo library")
    ADD_LIBRARY(podofo_shared SHARED ${PODOFO_BASE_SOURCES} ${PODOFO_DOC_SOURCES})
    TARGET_LINK_LIBRARIES(podofo_shared ${PODOFO_LIB_DEPENDS})
    # TODO: set /wd4251 flag if we're doing a debug build with
    # Visual Studio, since it produces invalid warnings about STL
    # use.
    SET_TARGET_PROPERTIES(podofo_shared PROPERTIES
        VERSION "${PODOFO_LIBVERSION}"
        SOVERSION "${PODOFO_SOVERSION}"
        CLEAN_DIRECT_OUTPUT 1
        OUTPUT_NAME "podofo"
        COMPILE_FLAGS "-DBUILDING_PODOFO"
        )
    # Since we're building a shared podofo, prefer to depend on this one for
    # tests and tools over the static library (if built).
    SET(PODOFO_DEPEND_TARGET podofo_shared
        CACHE INTERNAL "Which PoDoFo library variant to depend on")
    SET(USING_SHARED_PODOFO TRUE)
    INSTALL(TARGETS podofo_shared
        RUNTIME DESTINATION "bin"
        LIBRARY DESTINATION "${LIBDIRNAME}"
        ARCHIVE DESTINATION "${LIBDIRNAME}"
        )
ENDIF(PODOFO_BUILD_SHARED)

# Use these flags when compiling code that includes PoDoFo headers.
# Failure to do so will result in compilation or link-time errors
# on some platforms, and can even cause undefined results at runtime.
IF(WIN32 AND USING_SHARED_PODOFO)
    SET(PODOFO_CFLAGS "-DUSING_SHARED_PODOFO" CACHE INTERNAL "Extra flags required when linking to PoDoFo")
ELSE(WIN32 AND USING_SHARED_PODOFO)
    SET(PODOFO_CFLAGS "" CACHE INTERNAL "Extra flags required when linking to PoDoFo")
ENDIF(WIN32 AND USING_SHARED_PODOFO)

# Write the cflags and depend target to the config file
FILE(APPEND 
     "${PoDoFo_BINARY_DIR}/PoDoFoConfig.cmake"
     "SET(PODOFO_CFLAGS ${PODOFO_CFLAGS})\n"
     )
FILE(APPEND
     "${PoDoFo_BINARY_DIR}/PoDoFoConfig.cmake"
     "SET(PODOFO_DEPEND_TARGET ${PODOFO_DEPEND_TARGET})\n"
     )

=== test/CMakeLists.txt ===
SUBDIRS(
	ContentParser
	CreationTest
	DeviceTest
	FilterTest
	FormTest
	LargeTest
	ObjectParserTest
	ParserTest
	SignatureTest
	TokenizerTest
	VariantTest
	WatermarkTest
	unit
	)

=== tools/CMakeLists.txt ===
SUBDIRS(
	podofobox
	podofocolor
        podofocountpages
        podofocrop
	podofoencrypt
	podofogc
	podofoimgextract
	podofoimg2pdf
	podofomerge
	podofopages
	podofopdfinfo
	podofotxt2pdf
	podofotxtextract
	podofouncompress
	podofoimpose
	podofoincrementalupdates
	podofoxmp
	)

=== test/DeviceTest/CMakeLists.txt ===
ADD_EXECUTABLE(DeviceTest DeviceTest.cpp)
TARGET_LINK_LIBRARIES(DeviceTest ${PODOFO_LIB} ${PODOFO_LIB_DEPENDS})
SET_TARGET_PROPERTIES(DeviceTest PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(DeviceTest ${PODOFO_DEPEND_TARGET})

# Copy the test samples over to the build tree
ADD_CUSTOM_COMMAND(
    TARGET DeviceTest
    POST_BUILD
    COMMAND "${CMAKE_COMMAND}" -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/objects" "${CMAKE_CURRENT_BINARY_DIR}/objects"
    )

=== test/ParserTest/CMakeLists.txt ===
ADD_EXECUTABLE(ParserTest ParserTest.cpp)
TARGET_LINK_LIBRARIES(ParserTest ${PODOFO_LIB} ${PODOFO_LIB_DEPEND} )
SET_TARGET_PROPERTIES(ParserTest PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(ParserTest ${PODOFO_DEPEND_TARGET})

=== test/unit/CMakeLists.txt ===

IF(PODOFO_HAVE_CPPUNIT)
  INCLUDE_DIRECTORIES( ${PROJ_SOURCE_DIR}/src ${PROJ_BINARY_DIR}/src ${PROJ_BINARY_DIR}/src/os ${PROJ_BINARY_DIR}/src/os/${OROCOS_TARGET})
  ADD_DEFINITIONS("-g")
  
  # repeat for each test
  ADD_EXECUTABLE( podofo-test main.cpp ColorTest.cpp ElementTest.cpp EncodingTest.cpp EncryptTest.cpp 
		  FilterTest.cpp FontTest.cpp NameTest.cpp PagesTreeTest.cpp PageTest.cpp PainterTest.cpp
                  TokenizerTest.cpp StringTest.cpp VariantTest.cpp BasicTypeTest.cpp TestUtils.cpp DateTest.cpp )
  ADD_DEPENDENCIES( podofo-test ${PODOFO_DEPEND_TARGET})
  TARGET_LINK_LIBRARIES( podofo-test ${PODOFO_LIB} ${PODOFO_LIB_DEPENDS} ${CPPUNIT_LIBRARIES} )
  SET_TARGET_PROPERTIES( podofo-test PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
  ADD_TEST( podofo-test podofo-test )
ENDIF(PODOFO_HAVE_CPPUNIT)

=== tools/podofobox/CMakeLists.txt ===
ADD_EXECUTABLE(podofobox podofobox.cpp boxsetter.cpp)

TARGET_LINK_LIBRARIES(podofobox ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofobox PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofobox ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofobox
	RUNTIME DESTINATION "bin")

=== tools/podofocolor/CMakeLists.txt ===
SET(color_srcs
  podofocolor.cpp 
  colorchanger.cpp 
  colorspace.cpp
  graphicsstack.cpp
  iconverter.cpp
  dummyconverter.cpp
  grayscaleconverter.cpp
  )


SET(color_extra_libs)

IF(LUA_FOUND)
  SET(color_extra_libs ${LUA_LIBRARIES})
  SET(color_srcs ${color_srcs} luaconverter.cpp)
ENDIF(LUA_FOUND)

ADD_EXECUTABLE(podofocolor ${color_srcs} )

TARGET_LINK_LIBRARIES(podofocolor 
  ${PODOFO_LIB}
  ${color_extra_libs}
)

SET_TARGET_PROPERTIES(podofocolor PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofocolor ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofocolor
	RUNTIME DESTINATION "bin")

=== debian/changelog ===
libpodofo (0.9.3-4) unstable; urgency=medium

  * debian/control:
    + [2191c2f] add Vcs-{Git,Browser} fields.
    + [6045525] bump Standards-Version to 3.9.7, no changes needed.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 12 Mar 2016 00:47:22 +0000

libpodofo (0.9.3-3) unstable; urgency=medium

  * Upload to unstable.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 20 Jan 2016 23:02:04 +0000

libpodofo (0.9.3-2) experimental; urgency=medium

  * [5c9520e] debian/copyright: add src/base/PdfEncrypt.cpp with its own
    different copyright and license.
  * [9c11ffe] debian/control: remove libcppunit-dev from Build-Depends.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 20 Jan 2016 02:13:52 +0000

libpodofo (0.9.3-1) experimental; urgency=medium

  * [3c58af8] Imported Upstream version 0.9.3.  Closes: #660163, #806578
    + [400586e] debian/patches: drop freetype_multiarch and
      freetype_strikes_back as not needed anymore.
  * [6df14da] debian/{control,copyright}: take over the maintenance from malex.
  * [623244e] debian/{control,compat}: use compat level 9
  * debian/rules:
    + [ceea6ac] Rewrite using dh short format.
      - [dc7c312] debian/*.dirs: remove as useless now.
    + [f6a73cc] Remove some useless config flags.
    + [d000e53] Use dh_install --fail-missing.
    + [720ef58] Don't compress .pdf and .plan files.
    + [eb47012] Enable hardening.
  * debian/control:
    + [cf61ecb] Run wrap-and-sort.
    + [bc815bf] Bump Standards-Version to 3.9.6, no changes needed.
    + [2f0654e] Add some build-depends to enable optional features.
    + [8d64c36] Remove useless build-dependency on quilt.
    + [e5d72fa] Remove old and nowadays useless Replaces/Conflicts/Provides.
  * [4c0c7f1] Install the manpages using upstream's cmake rules, instead of
    listing all of them in debian/*.manpages.
  * [693131f] new SONAME, change library package name.
  * [c0a13c7] debian/libpodofo-utils.install: install some examples files for
    podofoimpose.  Closes: #639869
  * [d0c2ae6,128b998] debian/copyright: update.
  * [a8b91e6] debian/patches/FindZLIB.cmake: add a small description header.
  * [0a6b248] debian/watch: remove pointless comments.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 17 Jan 2016 18:30:58 +0000

libpodofo (0.9.0-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Import libstdc++ transition changes from Ubuntu (Closes: #791156)

  [ Steve Langasek ]
  * Rename library packages for g++5 ABI transition

 -- Simon McVittie <smcv@debian.org>  Thu, 27 Aug 2015 08:12:00 +0100

=== debian/control ===
Source: libpodofo
Priority: extra
Maintainer: Mattia Rizzolo <mattia@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 9),
 libfontconfig1-dev,
 libfreetype6-dev (>= 2.5),
 libidn11-dev,
 libjpeg-dev,
 liblua5.1-0-dev,
 zlib1g-dev,
 libssl-dev,
 libtiff-dev
Standards-Version: 3.9.7
Section: libdevel
Homepage: http://podofo.sourceforge.net/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/libpodofo.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/libpodofo.git

Package: libpodofo-dev
Architecture: any
Depends:
 libpodofo0.9.3 (= ${binary:Version}),
 ${misc:Depends}
Description: PoDoFo development files
 The PoDoFo library is a free, portable C++ library which includes classes to
 parse PDF files and modify their contents into memory. The changes can be
 written back to disk easily. The parser can also be used to extract
 information from a PDF file (for example the parser could be used in a PDF
 viewer). Besides parsing PoDoFo includes also very simple classes to create
 your own PDF files. All classes are documented so it is easy to start writing
 your own application using PoDoFo.
 .
 This package contains the header development files used for building
 PoDoFo-enabled applications.

Package: libpodofo-utils
Architecture: any
Depends:
 libpodofo0.9.3 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: PoDoFo utilities
 The PoDoFo library is a free, portable C++ library which includes classes to
 parse PDF files and modify their contents into memory. The changes can be
 written back to disk easily. The parser can also be used to extract
 information from a PDF file (for example the parser could be used in a PDF
 viewer). Besides parsing PoDoFo includes also very simple classes to create
 your own PDF files. All classes are documented so it is easy to start writing
 your own application using PoDoFo.
 .
 This package contains tools for working with PDF files.

Package: libpodofo0.9.3
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: PoDoFo - library to work with the PDF file format
 The PoDoFo library is a free, portable C++ library which includes classes to
 parse PDF files and modify their contents into memory. The changes can be
 written back to disk easily. The parser can also be used to extract
 information from a PDF file (for example the parser could be used in a PDF
 viewer). Besides parsing PoDoFo includes also very simple classes to create
 your own PDF files. All classes are documented so it is easy to start writing
 your own application using PoDoFo.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DWANT_FONTCONFIG:BOOL=TRUE \
	    -DWANT_BOOST:BOOL=1 \
	    -DPODOFO_BUILD_SHARED:BOOL=TRUE \
	    -DPODOFO_BUILD_STATIC:BOOL=FALSE \

override_dh_install:
	dh_install --fail-missing

override_dh_compress:
	dh_compress -X .pdf -X .plan

=== debian/watch ===
version=3

opts=dversionmangle=s/\+svn[0-9]+// http://sf.net/podofo/podofo-(.*)\.tar\.gz

## libpodofo 0.9.4

=== debian/changelog ===
libpodofo (0.9.4-6) unstable; urgency=high

  * Add upstream patches for security issues:
    + CVE-2017-5855 Closes: #854603
    + CVE-2017-6840 Closes: #861557
    + CVE-2017-6842 Closes: #861559
    + CVE-2017-6843 Closes: #861560
    + CVE-2017-6847 Closes: #861564
    + CVE-2017-6848 Closes: #861565
    + CVE-2017-7378 Closes: #859330
    + CVE-2017-7380 CVE-2017-7381 CVE-2017-7382 CVE-2017-7383 Closes: #859329

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 17 May 2017 14:54:40 +0200

libpodofo (0.9.4-5) unstable; urgency=high

  * Add upstream patches for security issues:
    + CVE-2017-5853 Closes: #854601
    + CVE-2017-6844 Closes: #861561
    + CVE-2017-5854 Closes: #854602
    + CVE-2017-5886 Closes: #854604
    + CVE-2017-7379 Closes: #859331

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 03 May 2017 11:41:19 +0200

libpodofo (0.9.4-4) unstable; urgency=medium

  * d/watch: fixup.

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 08 Dec 2016 15:10:41 +0100

libpodofo (0.9.4-3) unstable; urgency=medium

  * Bump debhelper compat level to 10.
    Drop explicit --parallel option, now default.
  * Add patch to make the PoDoFo compatible with OpenSSL 1.1.0 API.
    Thanks to Reiner Herrmann <reiner@reiner-h.de> for the patch.
    Closes: #828407
  * Install the docs also in libpodofo-utils.
  * d/watch: bump to version 4 and use of new substitutions patterns to catch
    eventual non-gzip releases.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 26 Oct 2016 23:32:42 +0000

libpodofo (0.9.4-2) unstable; urgency=medium

  * Upload to unstable.
  * Update copyright.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 20 Jun 2016 10:57:17 +0000

libpodofo (0.9.4-1) experimental; urgency=medium

  * Imported Upstream version 0.9.4.
  * debian/control: Bump Standards-Version to 3.9.8, no changes needed.
  * debian/copyright: update.
  * Refresh patches.
  * debian/watch: be more clever about rc releases.
  * Change package name after SONAME change.
  * d/man/podofocolor.1: fix syntax error.
  * d/man/podofoxmp: fix typos.

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 14 Jun 2016 09:45:43 +0000

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,16 @@
 Maintainer: Mattia Rizzolo <mattia@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 9),
+ debhelper (>= 10),
  libfontconfig1-dev,
  libfreetype6-dev (>= 2.5),
  libidn11-dev,
  libjpeg-dev,
  liblua5.1-0-dev,
+ libssl-dev,
+ libtiff-dev,
  zlib1g-dev,
- libssl-dev,
- libtiff-dev
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Section: libdevel
 Homepage: http://podofo.sourceforge.net/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/libpodofo.git
@@ -21,8 +21,8 @@
 Package: libpodofo-dev
 Architecture: any
 Depends:
- libpodofo0.9.3 (= ${binary:Version}),
- ${misc:Depends}
+ libpodofo0.9.4 (= ${binary:Version}),
+ ${misc:Depends},
 Description: PoDoFo development files
  The PoDoFo library is a free, portable C++ library which includes classes to
  parse PDF files and modify their contents into memory. The changes can be
@@ -38,9 +38,9 @@
 Package: libpodofo-utils
 Architecture: any
 Depends:
- libpodofo0.9.3 (= ${binary:Version}),
+ libpodofo0.9.4 (= ${binary:Version}),
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: PoDoFo utilities
  The PoDoFo library is a free, portable C++ library which includes classes to
  parse PDF files and modify their contents into memory. The changes can be
@@ -52,12 +52,12 @@
  .
  This package contains tools for working with PDF files.
 
-Package: libpodofo0.9.3
+Package: libpodofo0.9.4
 Section: libs
 Architecture: any
 Depends:
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: PoDoFo - library to work with the PDF file format
  The PoDoFo library is a free, portable C++ library which includes classes to
  parse PDF files and modify their contents into memory. The changes can be

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \

## libpodofo 0.9.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 SET(PODOFO_VERSION_MAJOR "0" CACHE STRING "Major part of PoDoFo version number")
 SET(PODOFO_VERSION_MINOR "9" CACHE STRING "Minor part of PoDoFo version number")
-SET(PODOFO_VERSION_PATCH "3" CACHE STRING "Patchlevel part of PoDoFo version number")
+SET(PODOFO_VERSION_PATCH "5" CACHE STRING "Patchlevel part of PoDoFo version number")
 SET(PODOFO_SOVERSION "${PODOFO_VERSION_MAJOR}.${PODOFO_VERSION_MINOR}.${PODOFO_VERSION_PATCH}")
 SET(PODOFO_LIBVERSION "${PODOFO_SOVERSION}")
 
@@ -22,9 +22,17 @@
 #
 INCLUDE(CheckIncludeFile)
 INCLUDE(CheckLibraryExists)
-INCLUDE(UsePkgConfig)
 INCLUDE(TestBigEndian)
 INCLUDE(CheckTypeSize)
+
+#
+# Setup CMake Policies
+#
+
+# Prefer files in CMAKE_MODULE_PATH over shipped ones in module directory
+CMAKE_POLICY(SET CMP0017 NEW) # https://cmake.org/cmake/help/v3.0/policy/CMP0017.html
+# Do not use export_library_dependencies() anymore
+CMAKE_POLICY(SET CMP0033 NEW) # https://cmake.org/cmake/help/v3.0/policy/CMP0033.html
 
 # Load modules from our source tree too
 SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
@@ -35,19 +43,35 @@
 # variable here that we require to be set elsewhere, otherwise we'll complain.
 SET(PODOFO_MAIN_CMAKELISTS_READ TRUE)
 
-
 # If the user hasn't told use specifically what they want, build only
-# a static library.
+# a static library or only a shared library on Windows.
 IF(NOT DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
-    SET(PODOFO_BUILD_STATIC TRUE)
-    SET(PODOFO_BUILD_SHARED FALSE)
+    IF(WIN32)
+        SET(PODOFO_BUILD_STATIC FALSE)
+        SET(PODOFO_BUILD_SHARED TRUE)
+    ELSE(WIN32)
+        SET(PODOFO_BUILD_STATIC TRUE)
+        SET(PODOFO_BUILD_SHARED FALSE)
+    ENDIF(WIN32)
 ENDIF(NOT DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
 IF(DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
-    SET(PODOFO_BUILD_SHARED NOT ${PODOFO_BUILD_SHARED})
+    IF(PODOFO_BUILD_SHARED)
+        SET(PODOFO_BUILD_STATIC FALSE)
+    ELSE(PODOFO_BUILD_SHARED)
+        SET(PODOFO_BUILD_STATIC TRUE)
+    ENDIF(PODOFO_BUILD_SHARED)
 ENDIF(DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
 IF(NOT DEFINED PODOFO_BUILD_SHARED AND DEFINED PODOFO_BUILD_STATIC)
-    SET(PODOFO_BUILD_SHARED NOT ${PODOFO_BUILD_STATIC})
+    IF(PODOFO_BUILD_STATIC)
+        SET(PODOFO_BUILD_SHARED FALSE)
+    ELSE(PODOFO_BUILD_STATIC)
+        SET(PODOFO_BUILD_SHARED TRUE)
+    ENDIF(PODOFO_BUILD_STATIC)
 ENDIF(NOT DEFINED PODOFO_BUILD_SHARED AND DEFINED PODOFO_BUILD_STATIC)
+
+IF(DEFINED LIB_SUFFIX)
+	SET(LIBDIRNAME "lib${LIB_SUFFIX}")
+ELSE(DEFINED LIB_SUFFIX)
 
 # Some 64 bit linux distros use /usr/lib64 for 64 bit libraries.
 # on these platforms we must
@@ -62,6 +86,8 @@
 ELSE(WANT_LIB64)
 	SET(LIBDIRNAME "lib")
 ENDIF(WANT_LIB64)
+
+ENDIF(DEFINED LIB_SUFFIX)
 MESSAGE("Will install libraries to ${CMAKE_INSTALL_PREFIX}/${LIBDIRNAME}")
 
 # Some headers that tend to vary a bit
@@ -153,19 +179,22 @@
            SET(pdfuint64 "unsigned long int")
 	   CHECK_TYPE_SIZE("long int" SZ_INT64)
          ELSE(SZ_LONG == 8 AND SZ_ULONG == 8)
-           # See if the compiler implements "long long int", _int64, int64, __int64 or int64_t
+           # See if the compiler implements "long long int", int64_t, int64,
+           # or _int64 (in this order, __int64 check already done)
            IF(PODOFO_HAVE_SYS_TYPES_H)
              SET(CMAKE_EXTRA_INCLUDE_FILES "sys/types.h")
            ENDIF(PODOFO_HAVE_SYS_TYPES_H)
            CHECK_TYPE_SIZE("long long int"          SZ_LONG_LONG)
            CHECK_TYPE_SIZE("unsigned long long int" SZ_UNSIGNED_LONG_LONG)
            IF(SZ_LONG_LONG == 8 AND SZ_UNSIGNED_LONG_LONG == 8)
-             SET(pdfint64 "long int")
-             SET(pdfuint64 "unsigned long int")
-	     CHECK_TYPE_SIZE("long int" SZ_INT64)
+             SET(pdfint64 "long long int")
+             SET(pdfuint64 "unsigned long long int")
+             CHECK_TYPE_SIZE("long long int" SZ_INT64)
            ELSE(SZ_LONG_LONG == 8 AND SZ_UNSIGNED_LONG_LONG == 8)
-             CHECK_TYPE_SIZE("int64_t"                SZ_INT64_T)
-             CHECK_TYPE_SIZE("uint64_t"               SZ_UINT64_T)
+             # The standard type int64_t is normally found in stdint.h,
+             # but use a type of this name anyway if present
+             CHECK_TYPE_SIZE("int64_t"       SZ_INT64_T)
+             CHECK_TYPE_SIZE("uint64_t"      SZ_UINT64_T)
              IF(SZ_INT64_T AND SZ_UINT64_T)
                SET(pdfint64 "int64_t")
                SET(pdfuint64 "uint64_t")
@@ -221,18 +250,9 @@
 TEST_BIG_ENDIAN(TEST_BIG)
 
 IF(WIN32)
-    # On win32 we support EITHER shared OR static builds.
-    # If both are enabled (default), turn off generation of the
-    # static library.
-    IF(PODOFO_BUILD_SHARED AND PODOFO_BUILD_STATIC)
-         MESSAGE("Both PODOFO_BUILD_SHARED and PODOFO_BUILD_STATIC set")
-         MESSAGE("  so disabling shared library generation (win32)")
-         SET(PODOFO_BUILD_SHARED FALSE)
-         SET(PODOFO_BUILD_STATIC TRUE)
-    ENDIF(PODOFO_BUILD_SHARED AND PODOFO_BUILD_STATIC)
     # We must explicitly link to the core win32 libraries, and we need winsock2
     # to get some byte-order conversion routines too.
-    SET(PLATFORM_SYSTEM_LIBRARIES kernel32 user32 gdi32 winspool comdlg32 advapi32 shell32 ole32 oleaut32 uuid WS2_32)
+    SET(PLATFORM_SYSTEM_LIBRARIES kernel32 user32 gdi32 winspool comdlg32 advapi32 shell32 ole32 oleaut32 uuid ws2_32)
     # Microsoft deprecate certain POSIX functions that we use.
     # for now, turn off these warnings.
     ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
@@ -247,16 +267,3 @@
 
 IF(UNIX AND NOT PODOFO_NO_FONTMANAGER)
     SET(WANT_FONTCONFIG TRUE CACHE INTERNAL
-        "True if PoDoFo should be built with fontconfig support")
-ELSE(UNIX AND NOT PODOFO_NO_FONTMANAGER)
-    SET(WANT_FONTCONFIG FALSE CACHE INTERNAL
-        "True if PoDoFo should be built with fontconfig support")
-ENDIF(UNIX AND NOT PODOFO_NO_FONTMANAGER)
-
-
-IF(CMAKE_COMPILER_IS_GNUCXX)
-    MESSAGE("Using gcc specific compiler options")
-    # We can be more specific about what we want out of g++
-    # than with most other compilers.
-
-    # Attempt to detect the gcc version. You must not rely on

=== tools/podofopdfinfo/CMakeLists.txt ===
ADD_EXECUTABLE(podofopdfinfo pdfinfo.cpp podofopdfinfo.cpp)
TARGET_LINK_LIBRARIES(podofopdfinfo ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofopdfinfo PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofopdfinfo ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofopdfinfo
	RUNTIME DESTINATION "bin")

=== tools/podofosign/CMakeLists.txt ===
ADD_EXECUTABLE(podofosign podofosign.cpp)

TARGET_INCLUDE_DIRECTORIES(podofosign PUBLIC ${LIBCRYPTO_INCLUDE_DIR})
TARGET_LINK_LIBRARIES(podofosign ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofosign PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofosign ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofosign
	RUNTIME DESTINATION "bin")

=== debian/changelog ===
libpodofo (0.9.5-9) unstable; urgency=medium

  * Add upstream patches for security issues:
    + CVE-2017-6845 Closes: #861562
    + CVE-2017-8054 Closes: #860995
    + CVE-2017-8378 Closes: #861597
    + CVE-2018-5295 Closes: #889511
    + CVE-2018-5308
  * d/control:
    + Move the packaging to salsa.debian.org.
    + Bump Standards-Version to 4.1.3, no changes needed.
    + Move libpodofo-utils to section utils.
  * d/rules: Move from the deprecated dh_install --fail-missing to dh_missing.
  * d/copyright: Bump copyright year for debian/*.
  * Bump debhelper compat level to 11.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 24 Feb 2018 11:38:43 +0100

libpodofo (0.9.5-8) unstable; urgency=medium

  * Bump shlibs version due to the added symbol in the previous upload.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 12 Nov 2017 16:13:05 +0100

libpodofo (0.9.5-7) unstable; urgency=medium

  * Add upstream patches for security issues:
    + CVE-2017-5852 Closes: #854600
    + CVE-2017-7994 Closes: #860930
    + CVE-2017-8787 Closes: #861738
  * debian/control:
    + Bump Standards-Version to 4.1.1:
      - Move from priority extra (deprecated) to optional.
    + Declare that libpodofo can be built without root: R³:no.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 12 Nov 2017 15:36:06 +0100

libpodofo (0.9.5-6) unstable; urgency=medium

  * Add patch removing -stdc++98 from the compiler flags.
    This fixes an FTBFS with cppunit 1.14.  Closes: #868911

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 31 Jul 2017 17:54:12 +0200

libpodofo (0.9.5-5) unstable; urgency=medium

  * Add dependency on libssl-dev and libboost-dev to libpodofo-dev.
  * Bump Standards-Version to 4.0.0, no changes needed.
  * Upload to unstable.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 21 Jun 2017 21:46:25 +0200

libpodofo (0.9.5-4) experimental; urgency=medium

  * d/copyright: correct xyz's email address.
  * Merge branch Debian uploads 0.9.4-5 and 0.9.4-6 into experimental, to get
    the security fixes here too.
  * Refresh patches.

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 23 May 2017 23:11:01 +0200

libpodofo (0.9.5-3) experimental; urgency=medium

  * Drop symbols file, symbols changes across all architectures, so it's too
    painful to track, and useless for this library.
  * Override lintian tag no-symbols-control-file.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 15 Feb 2017 23:27:29 +0100

libpodofo (0.9.5-2) experimental; urgency=medium

  * d/copyright: update
  * d/patches:
    + fix_test_on_32bit.patch: add to fix FTBFS on 32 bit architectures.
    + spelling_fixes.patch: add to fix some spelling errors.
  * d/man/*:
    + Update manpages from upstream.
    + Fix a spelling error.
  * d/*.doc-base: Register doc-base to libpodofo-dev and libpodofo-utils.
  * d/libpodofo0.9.5.symbols: add for proper symbol version tracking (despite
    this library changing SONAME with every single upstream release, so a tad
    pointless, but doesn't harm…).

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 15 Feb 2017 21:36:20 +0100

libpodofo (0.9.5-1) experimental; urgency=medium

  * New upstream version 0.9.5.
  * d/p/OpenSSL_1.1.0.patch: drop, applied upstream.
  * d/p/FindZLIB.cmake: drop, not really needed, and better have fewer patches.
  * d/libpodofo-dev.install: Install the new pkgconfig file.
  * Rename binary package after SONAME bump: libpodofo0.9.4 → libpodofo0.9.5.
  * d/control:
    + Add build-dependency on libcppunit-dev to build the tests.
    + Add build-dependency on libboost-dev to actually enable boost support.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 08 Feb 2017 18:11:53 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,12 @@
 Source: libpodofo
-Priority: extra
+Priority: optional
+Section: libdevel
 Maintainer: Mattia Rizzolo <mattia@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 10),
+ debhelper (>= 11),
+ libboost-dev,
+ libcppunit-dev,
  libfontconfig1-dev,
  libfreetype6-dev (>= 2.5),
  libidn11-dev,
@@ -12,16 +15,18 @@
  libssl-dev,
  libtiff-dev,
  zlib1g-dev,
-Standards-Version: 3.9.8
-Section: libdevel
-Homepage: http://podofo.sourceforge.net/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/libpodofo.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/libpodofo.git
+Standards-Version: 4.1.3
+Rules-Requires-Root: no
+Homepage: http://podofo.sourceforge.net
+Vcs-Git: https://salsa.debian.org/debian/libpodofo.git
+Vcs-Browser: https://salsa.debian.org/debian/libpodofo
 
 Package: libpodofo-dev
 Architecture: any
 Depends:
- libpodofo0.9.4 (= ${binary:Version}),
+ libboost-dev,
+ libpodofo0.9.5 (= ${binary:Version}),
+ libssl-dev,
  ${misc:Depends},
 Description: PoDoFo development files
  The PoDoFo library is a free, portable C++ library which includes classes to
@@ -37,8 +42,9 @@
 
 Package: libpodofo-utils
 Architecture: any
+Section: utils
 Depends:
- libpodofo0.9.4 (= ${binary:Version}),
+ libpodofo0.9.5 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: PoDoFo utilities
@@ -52,7 +58,7 @@
  .
  This package contains tools for working with PDF files.
 
-Package: libpodofo0.9.4
+Package: libpodofo0.9.5
 Section: libs
 Architecture: any
 Depends:

=== debian/rules ===
--- 
+++ 
@@ -13,8 +13,12 @@
 	    -DPODOFO_BUILD_SHARED:BOOL=TRUE \
 	    -DPODOFO_BUILD_STATIC:BOOL=FALSE \
 
-override_dh_install:
-	dh_install --fail-missing
+override_dh_missing:
+	dh_missing --fail-missing
+
+override_dh_makeshlibs:
+	dh_makeshlibs -plibpodofo0.9.5 -V'libpodofo0.9.5 (>= 0.9.5-7)'
+	dh_makeshlibs --remaining-packages
 
 override_dh_compress:
 	dh_compress -X .pdf -X .plan

=== debian/watch ===
version=4

opts=\
dversionmangle=s/\+svn[0-9]+//,\
uversionmangle=s/([\d.]+)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
http://sf.net/podofo/podofo@ANY_VERSION@@ARCHIVE_EXT@
